import java.io.IOException;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.HColumnDescriptor;
import org.apache.hadoop.hbase.HTableDescriptor;
import org.apache.hadoop.hbase.MasterNotRunningException;
import org.apache.hadoop.hbase.NamespaceDescriptor;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.ZooKeeperConnectionException;
import org.apache.hadoop.hbase.client.Admin;
import org.apache.hadoop.hbase.client.Connection;
import org.apache.hadoop.hbase.client.ConnectionFactory;
import org.apache.hadoop.hbase.client.HBaseAdmin;
import org.apache.hadoop.hbase.util.Bytes;

public class NameSpaceDemo {
	static Configuration conf = null;
	static Connection connection = null;
	static{
		conf = HBaseConfiguration.create();
		conf.set("hbase.rootdir", " hdfs://192.168.254.128:9000/hbase ");
		conf.set("hbase.master", "hdfs:// 192.168.254.128:60000");
		conf.set("hbase.zookeeper.property.clientPort", "2181");
		conf.set("hbase.zookeeper.quorum", "master,slave1,slave2");
	}
	
	public static void main(String[] args) throws MasterNotRunningException, ZooKeeperConnectionException, IOException {
		connection = ConnectionFactory.createConnection(conf);
//		1.0版本之前没问题，1.0之后该方法过期但仍可使用
//		HBaseAdmin admin = new HBaseAdmin(conf); 
		Admin admin = connection.getAdmin();
		NamespaceDescriptor namespaceDescriptor = NamespaceDescriptor.create("ns3").build();
        admin.createNamespace(namespaceDescriptor);
        //表名，同时指定命名空间
        TableName tableName = TableName.valueOf("ns3","stu");
        //表描述
        HTableDescriptor desc = new HTableDescriptor(tableName);
        //列族描述
        HColumnDescriptor coldef = new HColumnDescriptor(Bytes.toBytes("info"));
        //表加入列族
        desc.addFamily(coldef);
        //创建表
        admin.createTable(desc);
        //校验表是否可用
        boolean avail = admin.isTableAvailable(tableName);
        System.out.println("Table available: "+avail);
        //关闭连接
        if(admin != null)
        	admin.close();
        if(connection != null)
        	connection.close();
	}
}