import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.Cell;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.*;
import org.apache.hadoop.hbase.util.Bytes; 
import java.io.IOException;
 
public class MultipleCounterDemo{
	static Configuration conf = null;
	static Connection connection = null;
	static{
		conf = HBaseConfiguration.create();
		conf.set("hbase.rootdir", " hdfs://192.168.254.128:9000/hbase ");
		conf.set("hbase.master", "hdfs:// 192.168.254.128:60000");
		conf.set("hbase.zookeeper.property.clientPort", "2181");
		conf.set("hbase.zookeeper.quorum", "master,slave1,slave2");
	}
	
    public static void main(String args[]) throws IOException{
        connection = ConnectionFactory.createConnection(conf);
        Table table = connection.getTable(TableName.valueOf("counters3"));
        //incrementColumnValue(行号,列族,列,步长)
        Increment increment1 = new Increment(Bytes.toBytes("20180131"));
        increment1.addColumn(Bytes.toBytes("daily"),Bytes.toBytes("counter1"),1);
        increment1.addColumn(Bytes.toBytes("daily"),Bytes.toBytes("counter2"),1);
        increment1.addColumn(Bytes.toBytes("weekly"),Bytes.toBytes("counter1"),10);
        increment1.addColumn(Bytes.toBytes("weekly"),Bytes.toBytes("counter2"),10);
 
        Result result = table.increment(increment1);
        for(Cell cell : result.rawCells()){
            System.out.println("Cell: " + cell + " Value: " + 
            		Bytes.toLong(cell.getValueArray(), cell.getValueOffset(),cell.getValueLength()));
        }
 
        Increment increment2 = new Increment(Bytes.toBytes("20180131"));
        increment2.addColumn(Bytes.toBytes("daily"),Bytes.toBytes("counter1"), 5);
        increment2.addColumn(Bytes.toBytes("daily"),Bytes.toBytes("counter2"), 1);
        increment2.addColumn(Bytes.toBytes("weekly"),Bytes.toBytes("counter1"), 0);
        increment2.addColumn(Bytes.toBytes("weekly"),Bytes.toBytes("counter2"), -5);
        Result result2 = table.increment(increment2);
        for (Cell cell : result2.rawCells()) {
            System.out.println("Cell: " + cell +
                    " Value: " + Bytes.toLong(cell.getValueArray(),
                    cell.getValueOffset(), cell.getValueLength()));
        }

        table.close();
        if(connection != null)
        	connection.close();
    }
}