import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.*;
import org.apache.hadoop.hbase.filter.*;
import org.apache.hadoop.hbase.util.Bytes;
 
import java.io.IOException;
 
public class SingleCounterDemo{
	static Configuration conf = null;
	static Connection connection = null;
	static{
		conf = HBaseConfiguration.create();
		conf.set("hbase.rootdir", " hdfs://192.168.254.128:9000/hbase ");
		conf.set("hbase.master", "hdfs:// 192.168.254.128:60000");
		conf.set("hbase.zookeeper.property.clientPort", "2181");
		conf.set("hbase.zookeeper.quorum", "master,slave1,slave2");
	}
	
    public static void main(String args[]) throws IOException{
        connection = ConnectionFactory.createConnection(conf);
        Table table = connection.getTable(TableName.valueOf("counters2"));
        //incrementColumnValue(行号,列族,列,步长)
        long cnt1 = table.incrementColumnValue(Bytes.toBytes("20180131"),
        		Bytes.toBytes("daily"),Bytes.toBytes("counter"), 1);
        System.out.println(cnt1);
        long cnt2 = table.incrementColumnValue(Bytes.toBytes("20180131"),
        		Bytes.toBytes("daily"),Bytes.toBytes("counter"), 0);
        System.out.println(cnt2);
        long cnt3 = table.incrementColumnValue(Bytes.toBytes("20180131"),
        		Bytes.toBytes("daily"),Bytes.toBytes("counter"), -1);
        System.out.println(cnt3);
        long cnt4 = table.incrementColumnValue(Bytes.toBytes("20180131"),
        		Bytes.toBytes("daily"),Bytes.toBytes("counter"), 20);
        System.out.println(cnt4);
        table.close();
        
        if(connection != null)
        	connection.close();
    }
}