import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.*;
import org.apache.hadoop.hbase.protobuf.generated.HBaseProtos.SnapshotDescription;
import java.util.*; 
import java.io.IOException;
import java.text.SimpleDateFormat;
 
public class SnapShotDemo{
	static Configuration conf = null;
	static Connection connection = null;
	static{
		conf = HBaseConfiguration.create();
		conf.set("hbase.rootdir", " hdfs://192.168.254.128:9000/hbase ");
		conf.set("hbase.master", "hdfs:// 192.168.254.128:60000");
		conf.set("hbase.zookeeper.property.clientPort", "2181");
		conf.set("hbase.zookeeper.quorum", "master,slave1,slave2");
	}
	
    public static void main(String args[]) throws IOException{
        connection = ConnectionFactory.createConnection(conf);
        Admin admin = connection.getAdmin();
        TableName tableName = TableName.valueOf("stu2");
        admin.snapshot("snapStu2_1", tableName);
        SimpleDateFormat sdf = new SimpleDateFormat("YYYY-MM-dd hh:mm:ss");
        List<SnapshotDescription> snapshots = admin.listSnapshots();
        for(SnapshotDescription snapshot : snapshots){
        	System.out.print(snapshot.getName() + "\t" + snapshot.getTable() + "\t"
        			+ sdf.format(snapshot.getCreationTime()) + "\n");
        }
        
        connection.close();
        
        if(connection != null)
        	connection.close();
    }
}