import java.io.IOException;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.MasterNotRunningException;
import org.apache.hadoop.hbase.ZooKeeperConnectionException;
import org.apache.hadoop.hbase.client.Delete;
import org.apache.hadoop.hbase.client.HBaseAdmin;
import org.apache.hadoop.hbase.client.HTable;

public class DeleteDemo {
	static Configuration conf = null;
	static{
		conf = HBaseConfiguration.create();
		conf.set("hbase.rootdir", " hdfs://192.168.254.128:9000/hbase ");
		conf.set("hbase.master", "hdfs:// 192.168.254.128:60000");
		conf.set("hbase.zookeeper.property.clientPort", "2181");
		conf.set("hbase.zookeeper.quorum", "master,slave1,slave2");
	}
	
	public static boolean deleteQualifier(String tableName, String rowName, String columnFamilyName, String qualifierName) throws IOException {  
        HBaseAdmin admin = new HBaseAdmin(conf); 
        HTable table = new HTable(conf, tableName);
        if (admin.tableExists(tableName)) {  
            try {  
                Delete delete = new Delete(rowName.getBytes());  
                delete.deleteColumns(columnFamilyName.getBytes(), qualifierName.getBytes());
                table.delete(delete);  
            } catch (Exception e) {  
                e.printStackTrace(); 
                System.out.println("delete error");
                return false;  
            }  
        }
        System.out.println("delete success");
        return true;  
    }

	public static void main(String[] args) throws MasterNotRunningException, ZooKeeperConnectionException, IOException {
		deleteQualifier("stu", "rw001", "info", "name");
	}
}