import java.io.IOException;
import java.util.List;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.Cell;
import org.apache.hadoop.hbase.CellUtil;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.KeyValue;
import org.apache.hadoop.hbase.MasterNotRunningException;
import org.apache.hadoop.hbase.ZooKeeperConnectionException;
import org.apache.hadoop.hbase.client.Get;
import org.apache.hadoop.hbase.client.HTable;
import org.apache.hadoop.hbase.client.Result;

public class QueryDemo {
	static Configuration conf = null;
	static{
		conf = HBaseConfiguration.create();
		conf.set("hbase.rootdir", " hdfs://192.168.254.128:9000/hbase ");
		conf.set("hbase.master", "hdfs:// 192.168.254.128:60000");
		conf.set("hbase.zookeeper.property.clientPort", "2181");
		conf.set("hbase.zookeeper.quorum", "master,slave1,slave2");
	}
	
		
	public static Result queryByRow(String tableName, String rowkey) throws IOException{
		Get get = new Get(rowkey.getBytes());
		HTable table = new HTable(conf, tableName);
		return table.get(get);
	}
	
	public static void main(String[] args) throws MasterNotRunningException, ZooKeeperConnectionException, IOException {
		
		//按行查询数据(旧方法)
		Result result = queryByRow("stu", "rw001");
		List<KeyValue> values = result.list();
		System.out.println("COLUMN\t\t\tCELL ");
		for(KeyValue value : values){
			System.out.print(new String(value.getFamily()) + ":");
			System.out.print(new String(value.getQualifier()) + "\t\t");
			System.out.print("value = " + new String(value.getValue()) + ",");
			System.out.println("timestamp = " + value.getTimestamp());
		}
		
		System.out.println("----新方法----");
		//按行查询数据(新方法)
		Result result2 = queryByRow("stu", "rw002");
		Cell[] cells = result2.rawCells();
		System.out.println("COLUMN\t\t\tCELL ");
		for(Cell cell : cells){
			System.out.print(new String(CellUtil.cloneFamily(cell)) + ":");
			System.out.print(new String(CellUtil.cloneQualifier(cell)) + "\t\t");
			System.out.print("value = " + new String(CellUtil.cloneValue(cell)) + ",");
			System.out.println("timestamp = " + cell.getTimestamp());
		}
		
	}
}