import java.io.IOException;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.MasterNotRunningException;
import org.apache.hadoop.hbase.ZooKeeperConnectionException;
import org.apache.hadoop.hbase.client.HTable;
import org.apache.hadoop.hbase.client.Result;
import org.apache.hadoop.hbase.client.ResultScanner;
import org.apache.hadoop.hbase.client.Scan;
import org.apache.hadoop.hbase.filter.FirstKeyOnlyFilter;

public class RowCountDemo {
	static Configuration conf = null;
	static{
		conf = HBaseConfiguration.create();
		conf.set("hbase.rootdir", " hdfs://192.168.254.128:9000/hbase ");
		conf.set("hbase.master", "hdfs:// 192.168.254.128:60000");
		conf.set("hbase.zookeeper.property.clientPort", "2181");
		conf.set("hbase.zookeeper.quorum", "master,slave1,slave2");
	}
	
	public static long rowCount(String tableName) {
		long rowCount = 0;
		try {
				HTable table = new HTable(conf, tableName);
				Scan scan = new Scan();
				scan.setFilter(new FirstKeyOnlyFilter());
				ResultScanner resultScanner = table.getScanner(scan);
				for (Result result : resultScanner) {
					rowCount += result.size();
				}
		} catch (IOException e) {
			System.out.println("eroor");
		}
		return rowCount;
	}

	public static void main(String[] args) throws MasterNotRunningException, ZooKeeperConnectionException, IOException {
		System.out.println(rowCount("stu2"));
	}
}