package com.mr;

import java.io.IOException;
import java.util.List;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.KeyValue;
import org.apache.hadoop.hbase.client.Put;
import org.apache.hadoop.hbase.client.Result;
import org.apache.hadoop.hbase.client.Scan;
import org.apache.hadoop.hbase.io.ImmutableBytesWritable;
import org.apache.hadoop.hbase.mapreduce.TableMapReduceUtil;
import org.apache.hadoop.hbase.mapreduce.TableMapper;
import org.apache.hadoop.mapreduce.Job;

public class TableCopy{
    static Configuration conf = null;
    static{
        conf = HBaseConfiguration.create();
        conf.set("hbase.rootdir", " hdfs://192.168.254.128:9000/hbase ");
        conf.set("hbase.master", "hdfs:// 192.168.254.128:60000");
        conf.set("hbase.zookeeper.property.clientPort", "2181");
        conf.set("hbase.zookeeper.quorum", "master,slave1,slave2");
    }

    static class CopyMapper extends TableMapper<ImmutableBytesWritable,Put>{

        @Override
        protected void map(ImmutableBytesWritable key, Result value,
                           Context context) throws IOException, InterruptedException {
            // TODO Auto-generated method stub
            //将查询结果保存到list
            List<KeyValue> kvs =  value.list();
            Put p = new Put(key.get());
            //将结果装载到Put
            for(KeyValue kv : kvs)
                p.add(kv);
            //将结果写入到Reduce
            context.write(key, p);
        }

    }

    public static void main(String[] args)throws Exception{
        String srcTable = "stu6";
        String dstTable = "stu8";
        Scan sc = new Scan();
        sc.setCaching(10000);
        sc.setCacheBlocks(false);
        Job job = Job.getInstance(conf, "TableCopy");
        job.setJarByClass(TableCopy.class);
        job.setNumReduceTasks(0);
        TableMapReduceUtil.initTableMapperJob(srcTable, sc, CopyMapper.class, ImmutableBytesWritable.class, Result.class, job);
        TableMapReduceUtil.initTableReducerJob(dstTable, null, job);
        job.waitForCompletion(true);
    }
}
